﻿using System;
using System.Configuration;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Text;
using gov.va.med.VBECS.Communication.Clients;
using gov.va.med.VBECS.Communication.Common;
using gov.va.med.vbecs.DAL.VistALink.OpenLibrary.Messages;

namespace ClientDemo.Demos
{
    public class VistaConnection : IClientDemo
    {
        public void Dispose()
        {
        }

        public void Start()
        {
            Console.WriteLine("Press enter to connect to the server...");
            Console.ReadLine(); //Wait user to press enter

            //Read server IP address/ Port
            var serverIp = ConfigurationManager.AppSettings.Get("ServerIP");
            var serverPort = ConfigurationManager.AppSettings.Get("ServerPort");

            using (var client = ClientFactory.CreateClient<MockPinger>(new IPEndPoint(IPAddress.Parse(serverIp), int.Parse(serverPort))))
            {
                client.Connect();

                client.MessageReceived += client_message_received;
                client.Send(new VistALinkHeartbeatRequestMessage());
            }
        }

        static void client_message_received(object sender, MessageEventArgs e)
        {
            var message = e.Message as TextMessage; //Server only accepts text messages
            if (message == null && e.Message is RawDataMessage)
            {
                // Try to construct message from RawMessage
                message = new TextMessage(((RawDataMessage)e.Message).Data);
            }
            if (message == null) return;

            Console.WriteLine("Response from messager: " + message.Text);
        }
    }
}
