﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using gov.va.med.vbecs.Lock;

namespace gov.va.med.vbecs.Lock
{
    public class AppLockingException : LockingException
    {
        gov.va.med.vbecs.Common.StrRes.StringResourceItem _item;

		/// <summary>
		/// Constructor allowing the Message property to be set.
		/// </summary>
		/// <param name="res_item">String setting the message of the exception.</param>
        public AppLockingException(gov.va.med.vbecs.Common.StrRes.StringResourceItem res_item)
            : base(res_item.ResString)
		{
            _item = res_item;
		}

		/// <summary>
		/// Constructor allowing the Message and InnerException property to be set.
		/// </summary>
        /// <param name="res_item">String setting the message of the exception.</param>
		/// <param name="inner">Sets a reference to the InnerException.</param>
        public AppLockingException(gov.va.med.vbecs.Common.StrRes.StringResourceItem res_item, Exception inner)
            : base(res_item.ResString, inner)
		{
            _item = res_item;
		}

        public gov.va.med.vbecs.Common.StrRes.StringResourceItem Item
        {
            get { return _item; }
        }
    }
}
