﻿using System;
using System.Net;
using gov.va.med.VBECS.Communication.Common;

namespace gov.va.med.VBECS.Communication.Channels
{
    /// <summary>
    /// Generic interface represents Channel.
    /// </summary>
    public interface IChannel : IMessager
    {
        event EventHandler Disconnected;

        CommunicationStatus Status { get; }
        // TODO: this is acually generic interface and sholdn't refer EndPoint which is TCP/IP related only. Maybe this should be moved to other interface.
        IPEndPoint EndPoint { get; }

        void Start();
        void Disconnect();
    }
}
