﻿using gov.va.med.VBECS.Communication.Channels;

namespace gov.va.med.VBECS.Communication.Common
{

    /// <summary>
    /// Interface for pinger objects
    /// </summary>
    public interface IPinger
    {
        /// <summary>
        /// Starts pinger object
        /// </summary>
        void Start(IMessager messager);

        /// <summary>
        /// Stops pinger
        /// </summary>
        void Stop();

        /// <summary>
        /// Is called by hosting messenger when ping message is received
        /// </summary>
        void PingMessageReceived(IPingMessage msg);
    }
}
