﻿using gov.va.med.VBECS.Communication.Common;
using gov.va.med.VBECS.Communication.Utils;

namespace gov.va.med.VBECS.Communication.Protocols
{
    internal class MessagesProtocolEotFactory : IProtocolFactory
    {
        public IProtocol CreateProtocol()
        {
            return new MessagesProtocolEot(MessagesSerializer, MessagesFactory);
        }

        /// <summary>
        /// As soon as assigned, this property will be applied to all protocols created by this factory.
        /// TODO: this about assigning this property directly to protocol object. For example, add object ProtocolOption in ProtocolManager class and assign it from Spring.NET
        /// </summary>
        public IMessageSerializer MessagesSerializer { get; set; }

        public IMessageFactory MessagesFactory { get; set; }
    }
}
