﻿using System;
using System.IO;
using System.Reflection;

namespace gov.va.med.VBECS.VistaLinkServer.Core
{
    [Serializable]
    public class RemoteRunner
    {
        public object LoadDll(string assemblyNameLocation, string fullTypeName, string methodName, object[] parameters)
        {
            //load the assembly into bytes and load it
            var assemblyBytes = File.ReadAllBytes(assemblyNameLocation);
            var a = Assembly.Load(assemblyBytes);
            //find the type in the assembly
            var t = a.GetType(fullTypeName, true);
            //find the method "Run"
            var run = t.GetMethod(methodName);

            //run it (static method, no arguments)
            return run.Invoke(Activator.CreateInstance(t), parameters);
        }
    }
}
